Index: /trunk/sources/HeuristicLab.Operators/3.3/StochasticBranch.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/StochasticBranch.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/StochasticBranch.cs	(revision 2773)
@@ -23,44 +23,55 @@
 using System.Collections.Generic;
 using System.Text;
+using System.Xml;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Operators {
   /// <summary>
-  /// Branch of (one or) two operators that have different probabilities to get executed.
+  /// A branch of two operators which are executed with a specified probability.
   /// </summary>
-  public class StochasticBranch : OperatorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
+  [Item("StochasticBranch", "A branch of two operators which are executed with a specified probability.")]
+  [Creatable("Test")]
+  [EmptyStorableClass]
+  public class StochasticBranch : SingleSuccessorOperator {
+    public LookupParameter<IRandom> RandomParameter {
+      get { return (LookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public ValueLookupParameter<DoubleData> ProbabilityParameter {
+      get { return (ValueLookupParameter<DoubleData>)Parameters["Probability"]; }
+    }
+    protected OperatorParameter FirstBranchParameter {
+      get { return (OperatorParameter)Parameters["FirstBranch"]; }
+    }
+    protected OperatorParameter SecondBranchParameter {
+      get { return (OperatorParameter)Parameters["SecondBranch"]; }
+    }
+    public IOperator FirstBranch {
+      get { return FirstBranchParameter.Value; }
+      set { FirstBranchParameter.Value = value; }
+    }
+    public IOperator SecondBranch {
+      get { return SecondBranchParameter.Value; }
+      set { SecondBranchParameter.Value = value; }
     }
 
-    /// <summary>
-    /// Initializes a new instance of <see cref="StochasticBranch"/> with two variable infos
-    /// (<c>Random</c> and <c>Probability</c>).
-    /// </summary>
     public StochasticBranch()
       : base() {
-      AddVariableInfo(new VariableInfo("Random", "Pseudo random number generator", typeof(IRandom), VariableKind.In));
-      AddVariableInfo(new VariableInfo("Probability", "Probability to choose first branch", typeof(DoubleData), VariableKind.In));
+      Parameters.Add(new LookupParameter<IRandom>("Random", "A pseudo random number generator."));
+      Parameters.Add(new ValueLookupParameter<DoubleData>("Probability", "The probability to execute the first branch."));
+      Parameters.Add(new OperatorParameter("FirstBranch", "The operator which is executed with the given probability."));
+      Parameters.Add(new OperatorParameter("SecondBranch", "The operator which is executed if the first branch is not executed."));
     }
 
-    /// <summary>
-    /// Applies the operator of branch one with a specific probability on the given 
-    /// <paramref name="scope"/>, or - if existent - with another probability operator of branch two.  
-    /// </summary>
-    /// <param name="scope">The scope to apply the operators on.</param>
-    /// <returns>A new <see cref="AtomicOperation"/> with either operator 1 or operator 2 applied
-    /// to the given <paramref name="scope"/> or <c>null</c>.</returns>
-    public override IOperation Apply(IScope scope) {
-      IRandom random = GetVariableValue<IRandom>("Random", scope, true);
-      DoubleData probability = GetVariableValue<DoubleData>("Probability", scope, true);
-
-      bool result = random.NextDouble() < probability.Data;
-      if ((result) && (SubOperators.Count > 0) && (SubOperators[0] != null))
-        return new AtomicOperation(SubOperators[0], scope);
-      else if ((!result) && (SubOperators.Count > 1) && (SubOperators[1] != null))
-        return new AtomicOperation(SubOperators[1], scope);
-      return null;
+    public override IExecutionSequence Apply() {
+      ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
+      if (RandomParameter.ActualValue.NextDouble() < ProbabilityParameter.ActualValue.Value) {
+        if (FirstBranch != null) next.Insert(0, new ExecutionContext(ExecutionContext.Parent, FirstBranch, ExecutionContext.Scope));
+      } else {
+        if (SecondBranch != null) next.Insert(0, new ExecutionContext(ExecutionContext.Parent, SecondBranch, ExecutionContext.Scope));
+      }
+      return next;
     }
   }
Index: /trunk/sources/HeuristicLab.Operators/3.3/SubScopesCreater.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/SubScopesCreater.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/SubScopesCreater.cs	(revision 2773)
@@ -52,5 +52,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       int n = NumberOfSubScopesParameter.ActualValue.Value;
       for (int i = 0; i < n; i++)
Index: /trunk/sources/HeuristicLab.Operators/3.3/SubScopesRemover.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/SubScopesRemover.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/SubScopesRemover.cs	(revision 2773)
@@ -52,5 +52,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       IntData index = SubScopeIndexParameter.ActualValue;
       if (index != null)
Index: /trunk/sources/HeuristicLab.Operators/3.3/SubScopesSorter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/SubScopesSorter.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/SubScopesSorter.cs	(revision 2773)
@@ -59,5 +59,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       descending = DescendingParameter.ActualValue.Value;
       actualName = LookupParameter<DoubleData>.TranslateName(ValueParameter.Name, ExecutionContext);
Index: /trunk/sources/HeuristicLab.Operators/3.3/UniformParallelSubScopesProcessor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/UniformParallelSubScopesProcessor.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/UniformParallelSubScopesProcessor.cs	(revision 2773)
@@ -35,19 +35,12 @@
   [Creatable("Test")]
   [EmptyStorableClass]
-  public sealed class UniformParallelSubScopesProcessor : SingleSuccessorOperator {
-    private OperatorParameter OperatorParameter {
-      get { return (OperatorParameter)Parameters["Operator"]; }
-    }
-    public IOperator Operator {
-      get { return OperatorParameter.Value; }
-      set { OperatorParameter.Value = value; }
-    }
-
+  public sealed class UniformParallelSubScopesProcessor : SingleCallOperator {
     public UniformParallelSubScopesProcessor()
       : base() {
+      Parameters.Remove("Operator");
       Parameters.Add(new OperatorParameter("Operator", "The operator which should be applied on all sub-scopes of the current scope in parallel."));
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
       if (Operator != null) {
Index: /trunk/sources/HeuristicLab.Operators/3.3/UniformSequentialSubScopesProcessor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/UniformSequentialSubScopesProcessor.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/UniformSequentialSubScopesProcessor.cs	(revision 2773)
@@ -35,19 +35,12 @@
   [Creatable("Test")]
   [EmptyStorableClass]
-  public sealed class UniformSequentialSubScopesProcessor : SingleSuccessorOperator {
-    private OperatorParameter OperatorParameter {
-      get { return (OperatorParameter)Parameters["Operator"]; }
-    }
-    public IOperator Operator {
-      get { return OperatorParameter.Value; }
-      set { OperatorParameter.Value = value; }
-    }
-
+  public sealed class UniformSequentialSubScopesProcessor : SingleCallOperator {
     public UniformSequentialSubScopesProcessor()
       : base() {
+      Parameters.Remove("Operator");
       Parameters.Add(new OperatorParameter("Operator", "The operator which should be applied sequentially on all sub-scopes of the current scope."));
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       ExecutionContextCollection next = new ExecutionContextCollection(base.Apply());
       if (Operator != null) {
Index: /trunk/sources/HeuristicLab.Operators/3.3/ValuesCollector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/ValuesCollector.cs	(revision 2773)
+++ /trunk/sources/HeuristicLab.Operators/3.3/ValuesCollector.cs	(revision 2773)
@@ -0,0 +1,77 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Collections;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Operators {
+  /// <summary>
+  /// An operator which collects the actual values of parameters.
+  /// </summary>
+  [Item("ValuesCollector", "An operator which collects the actual values of parameters.")]
+  [Creatable("Test")]
+  public abstract class ValuesCollector : SingleSuccessorOperator, IOperator {
+    private ParameterCollection collectedValues;
+    [Storable]
+    public ParameterCollection CollectedValues {
+      get { return collectedValues; }
+      private set {
+        collectedValues = value;
+        collectedValues.ItemsAdded += new CollectionItemsChangedEventHandler<IParameter>(collectedValues_ItemsAdded);
+        collectedValues.ItemsRemoved += new CollectionItemsChangedEventHandler<IParameter>(collectedValues_ItemsRemoved);
+        collectedValues.CollectionReset += new CollectionItemsChangedEventHandler<IParameter>(collectedValues_CollectionReset);
+      }
+    }
+
+    public ValuesCollector()
+      : base() {
+      CollectedValues = new ParameterCollection();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      ValuesCollector clone = (ValuesCollector)base.Clone(cloner);
+      clone.CollectedValues = (ParameterCollection)cloner.Clone(collectedValues);
+      return clone;
+    }
+
+    private void collectedValues_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IParameter> e) {
+      Parameters.AddRange(e.Items);
+    }
+    private void collectedValues_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IParameter> e) {
+      Parameters.RemoveRange(e.Items);
+    }
+    #region NOTE
+    // NOTE: The ItemsReplaced event has not to be handled here as it is only fired when the name (i.e. key) of a parameter
+    // changes. As the same parameter is also contained in the Parameters collection of the operator, the Parameters collection
+    // will react on this name change on its own.
+    #endregion
+    private void collectedValues_CollectionReset(object sender, CollectionItemsChangedEventArgs<IParameter> e) {
+      Parameters.RemoveRange(e.OldItems);
+      Parameters.AddRange(e.Items);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.Operators/3.3/VariableInjector.cs
===================================================================
--- /trunk/sources/HeuristicLab.Operators/3.3/VariableInjector.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Operators/3.3/VariableInjector.cs	(revision 2773)
@@ -37,5 +37,5 @@
   [Creatable("Test")]
   [EmptyStorableClass]
-  public class VariableInjector : ValueCollector {
+  public class VariableInjector : ValuesCollector {
     protected ScopeParameter CurrentScopeParameter {
       get { return (ScopeParameter)Parameters["CurrentScope"]; }
@@ -50,5 +50,5 @@
     }
 
-    public override IExecutionContext Apply() {
+    public override IExecutionSequence Apply() {
       IVariable var;
       foreach (IParameter param in CollectedValues) {
Index: /trunk/sources/HeuristicLab.Parameters/3.3/LookupParameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters/3.3/LookupParameter.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Parameters/3.3/LookupParameter.cs	(revision 2773)
@@ -74,4 +74,35 @@
     }
 
+    private IValueParameter<T> GetParameter(out string name) {
+      IValueParameter<T> valueParam = this as IValueParameter<T>;
+      ILookupParameter<T> lookupParam = this as ILookupParameter<T>;
+      ExecutionContext current = ExecutionContext;
+
+      name = Name;
+      while ((valueParam != null) && (lookupParam != null)) {
+        if ((valueParam != null) && (valueParam.Value != null)) return valueParam;
+        if (lookupParam != null) name = lookupParam.ActualName;
+
+        current = current.Parent;
+        while ((current != null) && !current.Operator.Parameters.ContainsKey(name))
+          current = current.Parent;
+
+        if (current != null) {
+          valueParam = current.Operator.Parameters[name] as IValueParameter<T>;
+          lookupParam = current.Operator.Parameters[name] as ILookupParameter<T>;
+          if ((valueParam == null) && (lookupParam == null))
+            throw new InvalidOperationException(
+              string.Format("Parameter look-up chain broken. Parameter \"{0}\" is not an \"{1}\" or an \"{2}\".",
+                            name,
+                            typeof(IValueParameter<T>).GetPrettyName(),
+                            typeof(ILookupParameter<T>).GetPrettyName())
+            );
+        } else {
+          valueParam = null;
+          lookupParam = null;
+        }
+      }
+      return null;
+    }
     private IVariable LookupVariable(string name) {
       IScope scope = ExecutionContext.Scope;
@@ -81,15 +112,20 @@
     }
     protected override IItem GetActualValue() {
-      string name = TranslateName(Name, ExecutionContext);
-      IVariable var = LookupVariable(name);
-      if (var != null) {
-        T value = var.Value as T;
-        if (value == null)
-          throw new InvalidOperationException(
-            string.Format("Type mismatch. Variable \"{0}\" does not contain a \"{1}\".",
-                          name,
-                          typeof(T).GetPrettyName())
-          );
-        return value;
+      string name;
+      // try to get local value from context stack
+      IValueParameter<T> param = GetParameter(out name);
+      if (param != null) return param.Value;
+      else {  // try to get variable from scope
+        IVariable var = LookupVariable(name);
+        if (var != null) {
+          T value = var.Value as T;
+          if (value == null)
+            throw new InvalidOperationException(
+              string.Format("Type mismatch. Variable \"{0}\" does not contain a \"{1}\".",
+                            name,
+                            typeof(T).GetPrettyName())
+            );
+          return value;
+        }
       }
       return null;
@@ -102,8 +138,13 @@
                         typeof(T).GetPrettyName())
         );
-      string name = TranslateName(Name, ExecutionContext);
-      IVariable var = LookupVariable(name);
-      if (var != null) var.Value = val;
-      else ExecutionContext.Scope.Variables.Add(new Variable(name, val));
+      // try to get local value from context stack
+      string name;
+      IValueParameter<T> param = GetParameter(out name);
+      if (param != null) param.Value = val;
+      else {  // try to get variable from scope
+        IVariable var = LookupVariable(name);
+        if (var != null) var.Value = val;
+        else ExecutionContext.Scope.Variables.Add(new Variable(name, value));
+      }
     }
 
Index: /trunk/sources/HeuristicLab.Parameters/3.3/ValueLookupParameter.cs
===================================================================
--- /trunk/sources/HeuristicLab.Parameters/3.3/ValueLookupParameter.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Parameters/3.3/ValueLookupParameter.cs	(revision 2773)
@@ -33,18 +33,5 @@
   /// </summary>
   [Item("ValueLookupParameter<T>", "A parameter whose value is either defined it the parameter itself or is retrieved from or written to a scope.")]
-  public class ValueLookupParameter<T> : Parameter, IValueLookupParameter<T> where T : class, IItem {
-    [Storable]
-    private string actualName;
-    public string ActualName {
-      get { return actualName; }
-      set {
-        if (value == null) throw new ArgumentNullException();
-        if (!actualName.Equals(value)) {
-          actualName = value;
-          OnActualNameChanged();
-        }
-      }
-    }
-
+  public class ValueLookupParameter<T> : LookupParameter<T>, IValueLookupParameter<T> where T : class, IItem {
     private T value;
     [Storable]
@@ -61,29 +48,19 @@
     }
 
-    public new T ActualValue {
-      get { return (T)GetActualValue(); }
-      set { SetActualValue(value); }
-    }
-
     public ValueLookupParameter()
-      : base("Anonymous", typeof(T)) {
-      actualName = Name;
+      : base() {
     }
     public ValueLookupParameter(string name)
-      : base(name, typeof(T)) {
-      actualName = Name;
+      : base(name) {
     }
     public ValueLookupParameter(string name, T value)
-      : base(name, typeof(T)) {
-      actualName = Name;
+      : base(name) {
       Value = value;
     }
     public ValueLookupParameter(string name, string description)
-      : base(name, description, typeof(T)) {
-      actualName = Name;
+      : base(name, description) {
     }
     public ValueLookupParameter(string name, string description, T value)
-      : base(name, description, typeof(T)) {
-      actualName = Name;
+      : base(name, description) {
       Value = value;
     }
@@ -91,5 +68,4 @@
     public override IDeepCloneable Clone(Cloner cloner) {
       ValueLookupParameter<T> clone = (ValueLookupParameter<T>)base.Clone(cloner);
-      clone.actualName = actualName;
       clone.Value = (T)cloner.Clone(value);
       return clone;
@@ -100,85 +76,4 @@
     }
 
-    private IValueParameter<T> GetParameter(out string name) {
-      IValueParameter<T> valueParam = this;
-      ILookupParameter<T> lookupParam = this;
-      ExecutionContext current = ExecutionContext;
-
-      name = Name;
-      while ((valueParam != null) && (lookupParam != null)) {
-        if ((valueParam != null) && (valueParam.Value != null)) return valueParam;
-        if (lookupParam != null) name = lookupParam.ActualName;
-
-        current = current.Parent;
-        while ((current != null) && !current.Operator.Parameters.ContainsKey(name))
-          current = current.Parent;
-
-        if (current != null) {
-          valueParam = current.Operator.Parameters[name] as IValueParameter<T>;
-          lookupParam = current.Operator.Parameters[name] as ILookupParameter<T>;
-          if ((valueParam == null) && (lookupParam == null))
-            throw new InvalidOperationException(
-              string.Format("Parameter look-up chain broken. Parameter \"{0}\" is not an \"{1}\" or an \"{2}\".",
-                            name,
-                            typeof(IValueParameter<T>).GetPrettyName(),
-                            typeof(ILookupParameter<T>).GetPrettyName())
-            );
-        } else {
-          valueParam = null;
-          lookupParam = null;
-        }
-      }
-      return null;
-    }
-    private IVariable LookupVariable(string name) {
-      IScope scope = ExecutionContext.Scope;
-      while ((scope != null) && !scope.Variables.ContainsKey(name))
-        scope = scope.Parent;
-      return scope != null ? scope.Variables[actualName] : null;
-    }
-    protected override IItem GetActualValue() {
-      string name;
-      // try to get local value from context stack
-      IValueParameter<T> param = GetParameter(out name);
-      if (param != null) return param.Value;
-      else {  // try to get variable from scope
-        IVariable var = LookupVariable(name);
-        if (var != null) {
-          T value = var.Value as T;
-          if (value == null)
-            throw new InvalidOperationException(
-              string.Format("Type mismatch. Variable \"{0}\" does not contain a \"{1}\".",
-                            name,
-                            typeof(T).GetPrettyName())
-            );
-          return value;
-        }
-      }
-      return null;
-    }
-    protected override void SetActualValue(IItem value) {
-      T val = value as T;
-      if (val == null)
-        throw new InvalidOperationException(
-          string.Format("Type mismatch. Value is not a \"{0}\".",
-                        typeof(T).GetPrettyName())
-        );
-      // try to get local value from context stack
-      string name;
-      IValueParameter<T> param = GetParameter(out name);
-      if (param != null) param.Value = val;
-      else {  // try to get variable from scope
-        IVariable var = LookupVariable(name);
-        if (var != null) var.Value = val;
-        else ExecutionContext.Scope.Variables.Add(new Variable(name, value));
-      }
-    }
-
-    public event EventHandler ActualNameChanged;
-    private void OnActualNameChanged() {
-      if (ActualNameChanged != null)
-        ActualNameChanged(this, new EventArgs());
-      OnChanged();
-    }
     public event EventHandler ValueChanged;
     private void OnValueChanged() {
Index: /trunk/sources/HeuristicLab.Random/3.3/HeuristicLab.Random-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Random/3.3/HeuristicLab.Random-3.3.csproj	(revision 2772)
+++ /trunk/sources/HeuristicLab.Random/3.3/HeuristicLab.Random-3.3.csproj	(revision 2773)
@@ -85,15 +85,20 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="UniformRandomAdder.cs" />
-    <Compile Include="NormalRandomAdder.cs" />
+    <None Include="HeuristicLabRandomPlugin.cs.frame" />
+    <Compile Include="RandomInitializer.cs" />
     <Compile Include="HeuristicLabRandomPlugin.cs" />
-    <Compile Include="MersenneTwister.cs" />
-    <Compile Include="NormalDistributedRandom.cs" />
-    <Compile Include="NormalRandomizer.cs" />
+    <Compile Include="MersenneTwister.cs">
+      <SubType>Code</SubType>
+    </Compile>
+    <Compile Include="NormalDistributedRandom.cs">
+      <SubType>Code</SubType>
+    </Compile>
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="RandomInjector.cs" />
-    <Compile Include="UniformRandomizer.cs" />
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
+      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
+      <Name>HeuristicLab.Collections-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
       <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
@@ -107,4 +112,8 @@
       <Project>{23DA7FF4-D5B8-41B6-AA96-F0561D24F3EE}</Project>
       <Name>HeuristicLab.Operators-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
+      <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
+      <Name>HeuristicLab.Parameters-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
@@ -135,5 +144,6 @@
 set Outdir=$(Outdir)
 
-call PreBuildEvent.cmd</PreBuildEvent>
+call PreBuildEvent.cmd
+SubWCRev "%25ProjectDir%25\" "%25ProjectDir%25\HeuristicLabRandomPlugin.cs.frame" "%25ProjectDir%25\HeuristicLabRandomPlugin.cs"</PreBuildEvent>
   </PropertyGroup>
 </Project>
Index: /trunk/sources/HeuristicLab.Random/3.3/HeuristicLabRandomPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Random/3.3/HeuristicLabRandomPlugin.cs.frame	(revision 2773)
+++ /trunk/sources/HeuristicLab.Random/3.3/HeuristicLabRandomPlugin.cs.frame	(revision 2773)
@@ -0,0 +1,41 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Random {
+  /// <summary>
+  /// Plugin class for HeuristicLab.Random plugin.
+  /// </summary>
+  [Plugin("HeuristicLab.Random-3.3", "3.3.0.$WCREV$")]
+  [PluginFile("HeuristicLab.Random-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
+  [PluginDependency("HeuristicLab.Core", "3.3")]
+  [PluginDependency("HeuristicLab.Data", "3.3")]
+  [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
+  public class HeuristicLabRandomPlugin : PluginBase {
+  }
+}
Index: /trunk/sources/HeuristicLab.Random/3.3/MersenneTwister.cs
===================================================================
--- /trunk/sources/HeuristicLab.Random/3.3/MersenneTwister.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Random/3.3/MersenneTwister.cs	(revision 2773)
@@ -43,5 +43,6 @@
   /// A 623-Dimensionally Equidistributed Uniform Pseudo-Random Number Generator.
   /// </summary>
-  public class MersenneTwister : ItemBase, IRandom {
+  [Item("MersenneTwister", "A high-quality pseudo random number generator which creates uniformly distributed random numbers.")]
+  public class MersenneTwister : Item, IRandom {
     private const int n = 624, m = 397;
 
@@ -84,5 +85,5 @@
     /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="MersenneTwister"/>.</returns>
-    public override IItem Clone(ICloner cloner) {
+    public override IDeepCloneable Clone(Cloner cloner) {
       MersenneTwister clone = new MersenneTwister();
       cloner.RegisterClonedObject(this, clone);
Index: /trunk/sources/HeuristicLab.Random/3.3/NormalDistributedRandom.cs
===================================================================
--- /trunk/sources/HeuristicLab.Random/3.3/NormalDistributedRandom.cs	(revision 2772)
+++ /trunk/sources/HeuristicLab.Random/3.3/NormalDistributedRandom.cs	(revision 2773)
@@ -23,7 +23,7 @@
 using System.Collections.Generic;
 using System.Text;
-using HeuristicLab.Core;
 using System.Xml;
 using System.Globalization;
+using HeuristicLab.Core;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
@@ -35,6 +35,6 @@
   /// See "The Ziggurat Method for Generating Random Variables" (G. Marsaglia and W.W. Tsang 2000).
   /// </summary>
-  public class NormalDistributedRandom : ItemBase, IRandom {
-
+  [Item("NormalDistributedRandom", "A pseudo random number generator which uses the Ziggurat method to create normally distributed random numbers.")]
+  public class NormalDistributedRandom : Item, IRandom {
     [Storable]
     private double mu;
@@ -487,28 +487,22 @@
 
     /// <summary>
-    /// TODO: The method is not implemented.
-    /// </summary>
-    /// <returns>TODO</returns>
+    /// This method is not implemented.
+    /// </summary>
     public int Next() {
-      throw new Exception("The method or operation is not implemented.");
-    }
-
-    /// <summary>
-    /// TODO: The method is not implemented.
-    /// </summary>
-    /// <param name="maxVal">TODO</param>
-    /// <returns>TODO</returns>
+      throw new NotImplementedException();
+    }
+
+    /// <summary>
+    /// This method is not implemented.
+    /// </summary>
     public int Next(int maxVal) {
-      throw new Exception("The method or operation is not implemented.");
-    }
-
-    /// <summary>
-    /// TODO: The method is not implemented.
-    /// </summary>
-    /// <param name="minVal">TODO</param>
-    /// <param name="maxVal">TODO</param>
-    /// <returns>TODO</returns>
+      throw new NotImplementedException();
+    }
+
+    /// <summary>
+    /// This method is not implemented.
+    /// </summary>
     public int Next(int minVal, int maxVal) {
-      throw new Exception("The method or operation is not implemented.");
+      throw new NotImplementedException();
     }
 
@@ -561,5 +555,5 @@
     /// <param name="clonedObjects">Dictionary of all already cloned objects. (Needed to avoid cycles.)</param>
     /// <returns>The cloned object as <see cref="NormalDistributedRandom"/>.</returns>
-    public override IItem Clone(ICloner cloner) {
+    public override IDeepCloneable Clone(Cloner cloner) {
       NormalDistributedRandom clone = new NormalDistributedRandom((IRandom)cloner.Clone(uniform), mu, sigma);
       cloner.RegisterClonedObject(this, clone);
